import { Observable, SchedulerLike } from 'rxjs';
import { NumberGenerator } from '../utils/numberGenerator';
/**
 * Creates an Observable that emits sequential numbers in random intervals on a specified scheduler.
 *
 * @param min
 * @param max
 * @param generator Function returning a random number based on `min` and `max` parameters.
 * @param scheduler
 */
export declare const randomTimer: (min: number, max: number, generator?: NumberGenerator, scheduler?: SchedulerLike) => Observable<number>;
