"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var numberGenerator_1 = require("../utils/numberGenerator");
exports.randomTimer = function (min, max, generator, scheduler) {
    if (generator === void 0) { generator = numberGenerator_1.randomNumberGenerator; }
    if (scheduler === void 0) { scheduler = rxjs_1.asyncScheduler; }
    return rxjs_1.defer(function () {
        var index = 0;
        return rxjs_1.defer(function () { return rxjs_1.of(index++); }).pipe(operators_1.concatMap(function (value) { return rxjs_1.of(value).pipe(operators_1.delay(generator(min, max), scheduler)); }), operators_1.take(1), operators_1.repeat());
    });
};
//# sourceMappingURL=randomTimer.js.map