import { Subscriber, SchedulerLike } from 'rxjs';
/**
 * Observer for debugging purposes that timestamps each notification with time offset since the instance was created.
 */
export declare class DebugObserver<T> extends Subscriber<T> {
    private identifier;
    private logger;
    private scheduler?;
    private start;
    private readonly timeSinceStart;
    /**
     * @param identifier An identifier used in the header of each log.
     * @param logger Function used to log each message.
     * @param scheduler
     */
    constructor(identifier: string, logger?: (message?: any, ...optionalParams: any[]) => void, scheduler?: SchedulerLike);
    private messageTag;
    private log;
    private logComplete;
}
