"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var rxjs_1 = require("rxjs");
var now_1 = require("../utils/now");
var DebugObserver = (function (_super) {
    __extends(DebugObserver, _super);
    function DebugObserver(identifier, logger, scheduler) {
        if (logger === void 0) { logger = console.debug; }
        var _this = _super.call(this, function (v) { return _this.log('N', v); }, function (e) { return _this.log('E', e); }, function () { return _this.logComplete('C'); }) || this;
        _this.identifier = identifier;
        _this.logger = logger;
        _this.scheduler = scheduler;
        _this.start = now_1.schedulerNow(_this.scheduler);
        return _this;
    }
    Object.defineProperty(DebugObserver.prototype, "timeSinceStart", {
        get: function () {
            return now_1.schedulerNow(this.scheduler) - this.start;
        },
        enumerable: true,
        configurable: true
    });
    DebugObserver.prototype.messageTag = function (notificationType) {
        return "[" + this.identifier + "]" + notificationType + "@" + padWithZeroes(this.timeSinceStart, 7) + ":";
    };
    DebugObserver.prototype.log = function (notificationType, value) {
        this.logger(this.messageTag(notificationType), value);
    };
    DebugObserver.prototype.logComplete = function (notificationType) {
        this.logger(this.messageTag(notificationType));
    };
    return DebugObserver;
}(rxjs_1.Subscriber));
exports.DebugObserver = DebugObserver;
var padWithZeroes = function (number, length) {
    var myString = number.toString();
    while (myString.length < length) {
        myString = ' ' + myString;
    }
    return myString;
};
//# sourceMappingURL=DebugObserver.js.map