import { MonoTypeOperatorFunction } from 'rxjs';
/**
 * Emits an `error` notification when a value matches the predicate function.
 * If value matches the predicate, `errorWhen` will emit an error based on `errorOrFactory` parameter.
 *
 * @param predicate
 * @param errorOrFactory An object or a function used to generate error objects
 */
export declare const errorWhen: <T>(predicate: (value: T) => boolean, errorOrFactory?: any) => MonoTypeOperatorFunction<T>;
