import { MonoTypeOperatorFunction } from 'rxjs';
export declare enum FinalizeReason {
    Unsubscribe = "unsubscribe",
    Complete = "complete",
    Error = "error"
}
/**
 * Just like `finalize()` but passes to its callback also `reason` why the chain is being
 * disposed (chain completed, errored or on unsubscription).
 *
 * @param callback (reason: FinalizeReason) => void
 */
export declare const finalizeWithReason: <T>(callback: (reason: FinalizeReason) => void) => MonoTypeOperatorFunction<T>;
