"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var now_1 = require("../utils/now");
exports.queueTime = function (timeDelay, scheduler) {
    return function (source) { return rxjs_1.defer(function () {
        var nextEarliestEmission = null;
        return source.pipe(operators_1.concatMap(function (value) {
            var now = now_1.schedulerNow(scheduler);
            var expectedEmissionTime = nextEarliestEmission;
            if (expectedEmissionTime === null || now > expectedEmissionTime) {
                nextEarliestEmission = now + timeDelay;
                return rxjs_1.of(value);
            }
            else {
                var requiredDelay = expectedEmissionTime - now;
                nextEarliestEmission = now + timeDelay + requiredDelay;
                return rxjs_1.of(value).pipe(operators_1.delay(requiredDelay, scheduler));
            }
        }));
    }); };
};
//# sourceMappingURL=queueTime.js.map