"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
exports.retryTime = function (delayTime, scheduler) {
    return operators_1.retryWhen(function (errors) { return typeof delayTime === 'number'
        ? errors.pipe(operators_1.delay(delayTime, scheduler))
        : errors.pipe(operators_1.concatMap(function (e, index) { return delayTime.length === index
            ? rxjs_1.throwError(e)
            : rxjs_1.of(e).pipe(operators_1.delay(delayTime[index], scheduler)); })); });
};
//# sourceMappingURL=retryTime.js.map