import { BehaviorSubject } from 'rxjs';
import { PersistentStorage } from '../utils/storage';
/**
 * Just like `BehaviorSubject` but stores every item in a persistent storage (`LocalStorage` by default).
 */
export declare class PersistentSubject<T> extends BehaviorSubject<T> {
    private storageKey;
    private storage;
    constructor(storageKey: string, defaultValue: T, storage?: PersistentStorage<T>);
    next(value: T): void;
}
